// enableable.h

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/

// This is an interface class which adds the ability to enable and disable an
// object, and query whether it is enabled.

#ifndef ENABLEABLE_H
#define ENABLEABLE_H

#ifdef __GNUG__
#pragma interface
#endif

class Enableable {
public:
	Enableable(bool enab) : _enabled(enab) {}
	virtual ~Enableable();
	void enable(bool enabled);
	bool isEnabled() const { return _enabled; }
protected:
	virtual void doEnable(bool) = 0;
private:
	bool _enabled;
};


#endif

