// builtin.h
//
#ifndef __BUILTIN_H__
#define __BUILTIN_H__

inline bool even(int x) { return (x & 1) == 0; }
inline bool odd(int x) { return !even(x); }
inline double sign(double x) { return (x >= 0.0) ? 1.0 : -1.0; }

// NOTE:  This used to be defined elsewhere
typedef void (*two_arg_error_handler_t)(const char *, const char *);

extern two_arg_error_handler_t lib_error_handler;

#endif	//  __BUILTIN_H__
