// querylist.C

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/

#ifdef __GNUG__
#pragma implementation
#endif

#include "querylist.h"
#include "query.h"
#include "MyString.h"

QueryLink::QueryLink(QueryItem *q) {
	element = q;
	element->ref();
	next = nil;
}

QueryLink::~QueryLink() { Resource::unref(element); }


QueryList::QueryList(const char *label) {
	listLabel = new String(label ? label : "");
	head = nil;
}

QueryList::~QueryList() {
	delete listLabel;
	start();
	while(current) {
		register QueryLink *next = current->next;
		delete current;
		current = next;
	}
}

QueryLink *
QueryList::tail() {
	start();
	while(current && current->next)
		current = current->next;
	return current;
}
	
void
QueryList::append(QueryItem *q) {
	register QueryLink *link = new QueryLink(q);
	if(!head)
		head = link;
	else
		tail()->next = link;
	current = link;
}

const char *
QueryList::label() { return *listLabel; }
