// querylist.h

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/

#ifndef QUERYLIST_H
#ifdef __GNUG__
#pragma interface
#endif
#define QUERYLIST_H

#include "localdefs.h"

class QueryItem;

struct QueryLink {
	QueryLink(QueryItem *q);
	virtual ~QueryLink();
	QueryItem *element;
	QueryLink *next;
};

class String;

class QueryList {
public:
	QueryList(const char *lbl=nil);
	~QueryList();
	void append(QueryItem *);
	void start() { current = head; }
	boolean more() { return current != nil; }
	void next() { if(more()) current = current->next; }
	const char *label();
	QueryItem* item() { return current->element; }
private:
	QueryLink *tail();
private:
	String *listLabel;
	QueryLink *current;
	QueryLink *head;
};

class QueryButton;

class ButtonList : public QueryList {
public:
	ButtonList(const char *lbl=nil, Response defaultsTo=Yes)
		: QueryList(lbl), default_response(defaultsTo) {}
	QueryButton* item() { return (QueryButton *) QueryList::item(); }
	Response defaultResponse() { return default_response; }
private:
	Response default_response;
};

#endif
